import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id:biciMap

    orientationLock: PageOrientation.LockPortrait

    tools: ToolBarLayout {
        ToolIcon { iconId: "toolbar-back"; onClicked: { mainMenu.close(); pageStack.pop(); } }
        ToolIcon {
            Image {
                visible: true
                source: "images/geo-icon.png"
                anchors.verticalCenter: parent.verticalCenter
                anchors.horizontalCenter: parent.horizontalCenter
            }
            onClicked: pageStack.push(Qt.resolvedUrl("NearStations.qml"))
        }
        ToolIcon {
            iconId: "toolbar-search"
            onClicked: pageStack.push(Qt.resolvedUrl("SearchStations.qml"))
        }
        ToolIcon {
            iconId: "toolbar-view-menu"
            onClicked: (mainMenu.status == DialogStatus.Closed) ? mainMenu.open() : mainMenu.close()
            anchors.right: parent===undefined ? undefined : parent.right
        }
    }

    Flickable {
        id:container
        width:parent.width
        height: biciMap.height
        contentWidth: map.width
        contentHeight: map.height
        contentX: map.width /3
        contentY: map.height /4

        Image {
            id: map
            source: "images/map.jpg"
            width:920
            height: 1095
        }
    }

    Rectangle {
        width: biciMap.width
        height:32
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        id: banner
        opacity: 0.8
        z:10
        color:"#000"
        Text {
            text: "Fuente: Gobierno de la Ciudad de Buenos Aires."
            font.pixelSize:16
            anchors.left: parent.left
            anchors.verticalCenter: parent.verticalCenter
            anchors.leftMargin: 2
            color:"#fff"
        }
    }
}
