function DbManager () {
    this.db = null;
    this.initialize();
}

DbManager.prototype.initialize = function() {
    this.getDatabase();
    this.createTables();

    if(this.checkDB()) {
        this.initializeLinesData();
    }
}

DbManager.prototype.getDatabase = function(){
    this.db = openDatabaseSync("BiciGo102", "1.0", "Bici DB", 1000000);
    return true;
}

DbManager.prototype.checkDB = function() {
    var check = true;
    this.db.transaction(
             function(tx) {
                 var rs = tx.executeSql('SELECT * FROM stations;');
                 if (rs && rs.rows && rs.rows.length > 0) {
                     check =  false
                 } else {
                     check = true
                 }
             });
    return check;
}

// Create Tables

DbManager.prototype.createTables = function () {
    var tableExist = false
    var res = this;
    this.db.transaction(
             function(tx) {
                 tx.executeSql('CREATE TABLE IF NOT EXISTS stations(id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, name TEXT, address TEXT, lat TEXT, long TEXT)');
             });
}

// Populate DB

DbManager.prototype.initializeLinesData = function() {
    this.db.transaction(
             function(tx) {
                 var rs = tx.executeSql('SELECT * FROM stations WHERE id=1');
                 if (!(rs.rows.length > 0)) {

                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 1,'Facultad de Derecho','Av. Pres. Figueroa Alcorta 2050','-34.584288','-58.389505' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 2,'Retiro','Av. Dr. José M. Ramos Mejía 1350','-34.591778','-58.374206' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 3,'Aduana','Av. Paseo Colón 300','-34.611303','-58.36928' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 4,'Plaza Roma','Bouchard 550','-34.60083','-58.370056' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 5,'Plaza Italia','Av. Santa Fe 4100','-34.581081','-58.421549' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 6,'Parque Lezama','Av. Brasil 200','-34.625307','-58.368314' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 7,'Obelisco','Tte. Gral. Juan D. Perón 1050','-34.605952','-58.381324' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 8,'Congreso','Virrey Ceballos 50','-34.6092720','-58.389364' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 9,'Las Heras','Coronel Díaz 2400','-34.5851','-58.408495' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 10,'UCA Puerto Madero','Av. Alicia Moreau de Justo 1500','-34.616248','-58.366018' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 11,'Tribunales','Talcahuano 600','-34.601007','-58.385201' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 12,'Plaza Vicente López','Av. Las Heras 1700','-34.593403','-58.389626' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 13,'Once','Av. Rivadavia y Av. Pueyrredón','-34.60929','-58.406486' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 14,'Pacífico','Av. Santa Fe y Av. Bullrich','-34.577627','-58.42697' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 15,'Virrey Ceballos','Virrey Ceballos y Av. San Juan','-34.622327','-58.389079' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 16,'Plaza Houssay','Av. Córdoba 2100','-34.599241','-58.39837' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 17,'Plaza de Mayo','Av Pres. Julio A. Roca y Peru','-34.610078','-58.375064' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 18,'Plaza Almagro','Tte. Gral. Juan D. Perón 3700','-34.605559','-58.419221' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 19,'CMD','Algarrobo 1040','-34.654824','-58.3793' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 20,'Independencia','Av. 9 de Julio y Av. Independencia','-34.617405','-58.380503' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 21,'Plaza San Martín','Av. Santa Fe y Maipu','-34.59482','-58.37717' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 22,'Distrito Audiovisual','Av. Dorrego 1800','-34.5804','-58.4424' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 23,'Parque Patricios','Av. Caseros 3200','-34.6381','-58.4103' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 24,'Arenales','Arenales 1000','-34.5941','-58.3826' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 25,'Suipacha','Viamonte 850','-34.6002','-58.3792' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 26,'Alsina','Alsina 1000','-34.6106','-58.3809' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 27,'Plaza Güemes','Jerónimo Salguero 1750','-34.5896','-58.4164' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 28,'Emma de la Barra','Emma de la Barra 450','-34.6005','-58.3637' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 29,'Montevideo','Montevideo 800','-34.5995','-58.3897' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 30,'Plaza Boedo','Carlos Calvo 3300','-34.623','-58.4123' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 31,'Parque Centenario','Av. Díaz Vélez 4700','-34.608','-58.4345' ]);
                     tx.executeSql('INSERT INTO Stations VALUES(?, ?, ?, ?, ?)', [ 32,'Emilio Mitre','José Andrés Pacheco de Melo 2300','-34.5884','-58.3977' ]);

                 }
             });
    return true;
}

// Queries

DbManager.prototype.getStationsData = function() {
    var res="";

    this.db.transaction(
             function(tx) {
                 var rs = tx.executeSql('SELECT * FROM stations;');
                 if (rs.rows.length > 0) {
                     res = rs;
                 } else {
                     res = "error";
                 }
             })
    return res;
}

DbManager.prototype.getStationData = function(station_id) {
    var res="";

    this.db.transaction(
             function(tx) {
                 var rs = tx.executeSql('SELECT * FROM stations WHERE id = ?', [station_id]);

                 if (rs.rows.length > 0) {
                     res = rs;
                 } else {
                     res = "error";
                 }
             })
    return res;
}

DbManager.prototype.getClosestStations = function() {
    var res="";
    this.db.transaction(
             function(tx) {
                 var rs = tx.executeSql('SELECT * FROM Stations;');
                 if (rs.rows.length > 0) {
                     res = rs;
                 } else {
                     res = "error";
                 }
             })
    return res;
}
