Qt.include("db.js");

var dbManager;
init();


function init() {
    dbManager = new DbManager();
}


// Models

function generateStationsModel(model) {
    var obj = new Object();
    var res = dbManager.getStationsData();
    if (res == "error") {
        return;
    }

    model.clear();

    for(var i = 0; i < res.rows.length; i++) {
        obj.id = res.rows.item(i).id;
        obj.name = res.rows.item(i).name;
        obj.address = res.rows.item(i).address;
        obj.mapLat = res.rows.item(i).lat;
        obj.mapLong = res.rows.item(i).long;

        model.insert(i, obj);
        obj = {};
    }

    return;
}

function generateStationModel(model, station_id) {
    var obj = new Object();
    var res = dbManager.getStationData(station_id);
    if (res == "error") {
        return;
    }

    model.clear();

    for(var i = 0; i < res.rows.length; i++) {

        obj.name = res.rows.item(i).name;
        obj.address = res.rows.item(i).address;
        obj.mapLat = res.rows.item(i).lat;
        obj.mapLong = res.rows.item(i).long;

        model.insert(i, obj);
        obj = {};
    }

    return;
}

// Geolocation Functions



function update_location(lat, lon){
    console.log("Updating location");
    defaultLocation.latitude = lat;
    defaultLocation.longitude = lon;
}

function get_distance(lat2, lon2) {
    var dest = Qt.createQmlObject('import QtQuick 1.1; import QtMobility.location 1.2; Coordinate {latitude:'+lat2+';longitude:'+lon2+'}', window);
    return (defaultLocation.distanceTo(dest)).toFixed(0);
}

function distance_sort(a, b){
    return a.distance - b.distance;
}

function generateClosestStationsModel(model) {
    var obj = new Object();
    var res = dbManager.getClosestStations();

    if (res == "error") {
        return;
    }

    var closest = [];
    model.clear();

    for(var i = 0; i < res.rows.length; i++) {
        var station = res.rows.item(i);
        station.distance = get_distance(station.lat, station.long);
        closest.push(station);
    }

    closest.sort(distance_sort);
    closest.length = 10;

    for (var c in closest){
            model.append(closest[c]);
        }

    console.log("Closest Stations Model done")

    return;
}



function searchLocation(lat, lon){
    console.log("Searching location" + lat + " " + lon);
    resultLocation.latitude = lat;
    resultLocation.longitude = lon;
}


function getDistanceFromDestiny(lat2, lon2) {
    var dest = Qt.createQmlObject('import QtQuick 1.1; import QtMobility.location 1.2; Coordinate {latitude:'+lat2+';longitude:'+lon2+'}', window);
    console.log(resultLocation.distanceTo(dest))
    return (resultLocation.distanceTo(dest)).toFixed(0);
}

function generateClosestStationsByDestinyModel(model) {
    var obj = new Object();
    var res = dbManager.getClosestStations();

    if (res == "error") {
        return;
    }

    var closest = [];

    model.clear();

    for(var i = 0; i < res.rows.length; i++) {
        var station = res.rows.item(i);
        station.distance = getDistanceFromDestiny(station.lat, station.long);
        closest.push(station);
    }

    closest.sort(distance_sort);
    closest.length = 10;

    for (var c in closest){
            model.append(closest[c]);
        }

    console.log("Closest Stations by Destiny Model done")

    return;
}
