import QtQuick 1.1
import com.nokia.meego 1.0
import QtMobility.location 1.2
import "main.js" as MainManager

PageStackWindow {
    id: window

    property int station_id

    property double mapLat: 0.0
    property double mapLong: 0.0



    function getManager(){
        return MainManager;
    }

    Coordinate {
        id: defaultLocation
        latitude: -34.605952
        longitude: -58.381324
    }

    Coordinate {
        id: resultLocation
        latitude: -34.605952
        longitude: -58.381324
    }

//    PositionSource {
//        id: currentLocation
//        updateInterval:1000
//        active: true

//        onPositionChanged: {

//            if (currentLocation.position.latitudeValid == true){
//                gpsStauts = true
//                console.log(gpsStauts)
//            }
//            else {
//                gpsStauts = false
//                console.log(gpsStauts)
//            }

//            MainManager.update_location(currentLocation.position.coordinate.latitude,currentLocation.position.coordinate.longitude);
//            window.getManager().generateClosestStationsModel(closestStationsModel);
//        }
//    }

//    ListModel {
//        id: closestStationsModel
//    }

    platformStyle: defaultStyle;
    property bool enableSwipe: true

    PageStackWindowStyle { id: defaultStyle }
    initialPage: MainPage { }

    Splash {
        id: splash
        timeout: 1000
        fadeout: 600
        Component.onCompleted: splash.activate();
        onFinished: {
            pageStack.visible = true;
            splash.destroy();
        }
    }

    QueryDialog {
        id: about
        icon: "images/icon.png"
        titleText: "Acerca de BiciGo"
        message: "BiciGo 1.0.3<br/><br/>"
        + "© Copyright 2011 realnorth.<br/>All rights reserved.<br/><br/>"
        + "http://realnorth.net"
        acceptButtonText: "Cerrar"
    }

    Menu {
        id: mainMenu
        content: MenuLayout {
            MenuItem {
                text: "Acerca de BiciGo"
                onClicked: about.open()
            }
            MenuItem {
                text: "Teléfonos Útiles"
                onClicked: pageStack.push(Qt.resolvedUrl("EmergencyPage.qml"))
            }
            MenuItem {
                text: "Información Acerca del Servicio"
                onClicked: pageStack.push(Qt.resolvedUrl("InfoPage.qml"))
            }
            MenuItem {
                text: "Mapa de la Red"
                onClicked: pageStack.push(Qt.resolvedUrl("BiciMap.qml"))
            }
            MenuItem {
                text: "Buscar Estaciones por Dirección"
                onClicked: pageStack.push(Qt.resolvedUrl("SearchStations.qml"))
            }
        }
    }

    ToolBarLayout {
        id: commonTools
        visible: false
        ToolIcon { iconId: "toolbar-back"; onClicked: { mainMenu.close(); pageStack.pop(); } }
        ToolIcon {
            iconId: "toolbar-search"
            onClicked: pageStack.push(Qt.resolvedUrl("SearchStations.qml"))
        }
        ToolIcon { iconId: "toolbar-view-menu"; onClicked: (mainMenu.status == DialogStatus.Closed) ? mainMenu.open() : mainMenu.close() }
    }
}
